commit 0e00d0b2474183daa11ee1f18cab3e6fba2ebc18
Author: freddy77 <freddy77>
Date:   Thu Mar 13 13:23:30 2008 +0000

    simplify error.c

diff --git a/ChangeLog b/ChangeLog
index 0735575..cfa0bba 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,11 @@
+Thu Mar 13 14:22:28 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/error.c:
+	- make errs offset constant in all odbc structures to make 
+	  error.c simpler
+	- support SQL_HANDLE_DESC in SQLGetDiagField 
+	* src/odbc/odbc.c: remove TODO comment
+	* src/odbc/odbc_checks.c: typo
+
 Wed Mar 12 15:25:11 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/error.c: check proper handle type
 
@@ -219,4 +227,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2503 2008/03/12 14:26:07 freddy77 Exp $
+$Id: ChangeLog,v 1.2504 2008/03/13 13:23:30 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index a58d547..5efd600 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.104 2008/01/14 19:21:06 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.105 2008/03/13 13:23:31 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -177,11 +177,11 @@ struct _drecord
 struct _hdesc
 {
 	SQLSMALLINT htype;	/* do not reorder this field */
+	struct _sql_errors errs;	/* do not reorder this field */
 	int type;
 	SQLHANDLE parent;
 	struct _dheader header;
 	struct _drecord *records;
-	struct _sql_errors errs;
 };
 
 typedef struct _hdesc TDS_DESC;
@@ -202,13 +202,14 @@ struct _heattr
 struct _hchk
 {
 	SQLSMALLINT htype;	/* do not reorder this field */
+	struct _sql_errors errs;	/* do not reorder this field */
 };
 
 struct _henv
 {
 	SQLSMALLINT htype;	/* do not reorder this field */
+	struct _sql_errors errs;	/* do not reorder this field */
 	TDSCONTEXT *tds_ctx;
-	struct _sql_errors errs;
 	struct _heattr attr;
 };
 
@@ -242,6 +243,7 @@ struct _hstmt;
 struct _hdbc
 {
 	SQLSMALLINT htype;	/* do not reorder this field */
+	struct _sql_errors errs;	/* do not reorder this field */
 	struct _henv *env;
 	TDSSOCKET *tds_socket;
 	DSTR dsn;
@@ -254,7 +256,6 @@ struct _hdbc
 	struct _hstmt *current_statement;
 	/** list of all statements allocated from this connection */
 	struct _hstmt *stmt_list;
-	struct _sql_errors errs;
 	struct _hcattr attr;
 	/** descriptors associated to connection */
 	TDS_DESC *uad[TDS_MAX_APP_DESC];
@@ -326,6 +327,7 @@ typedef enum
 struct _hstmt
 {
 	SQLSMALLINT htype;	/* do not reorder this field */
+	struct _sql_errors errs;	/* do not reorder this field */
 	struct _hdbc *dbc;
 	/** query to execute */
 	char *query;
@@ -361,7 +363,6 @@ struct _hstmt
 	TDS_ODBC_ROW_STATUS row_status;
 	/* do NOT free dynamic, free from socket or attach to connection */
 	TDSDYNAMIC *dyn;
-	struct _sql_errors errs;
 	TDS_DESC *ard, *ird, *apd, *ipd;
 	TDS_DESC *orig_ard, *orig_apd;
 	SQLULEN sql_rowset_size;
diff --git a/src/odbc/error.c b/src/odbc/error.c
index 260e475..c9e0772 100644
--- a/src/odbc/error.c
+++ b/src/odbc/error.c
@@ -47,7 +47,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: error.c,v 1.50 2008/03/12 14:26:07 freddy77 Exp $");
+TDS_RCSID(var, "$Id: error.c,v 1.51 2008/03/13 13:23:31 freddy77 Exp $");
 
 static void odbc_errs_pop(struct _sql_errors *errs);
 static const char *odbc_get_msg(const char *sqlstate);
@@ -503,7 +503,7 @@ _SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 	       SQLINTEGER FAR * pfNativeError, SQLCHAR * szErrorMsg, SQLSMALLINT cbErrorMsgMax, SQLSMALLINT FAR * pcbErrorMsg)
 {
 	SQLRETURN result;
-	struct _sql_errors *errs = NULL;
+	struct _sql_errors *errs;
 	const char *msg;
 	char *p;
 
@@ -518,31 +518,28 @@ _SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 	if (numRecord <= 0 || cbErrorMsgMax < 0)
 		return SQL_ERROR;
 
-	if (!handle || ((struct _hchk *) handle)->htype != handleType)
+	if (!handle || ((TDS_CHK *) handle)->htype != handleType)
 		return SQL_INVALID_HANDLE;
 
+	errs = &((TDS_CHK *) handle)->errs;
 	switch (handleType) {
 	case SQL_HANDLE_STMT:
 		odbc_ver = ((TDS_STMT *) handle)->dbc->env->attr.odbc_version;
-		errs = &((TDS_STMT *) handle)->errs;
 		break;
 
 	case SQL_HANDLE_DBC:
 		odbc_ver = ((TDS_DBC *) handle)->env->attr.odbc_version;
-		errs = &((TDS_DBC *) handle)->errs;
 		break;
 
 	case SQL_HANDLE_ENV:
 		odbc_ver = ((TDS_ENV *) handle)->attr.odbc_version;
-		errs = &((TDS_ENV *) handle)->errs;
 		break;
 	case SQL_HANDLE_DESC:
 		parent = ((TDS_DESC *) handle)->parent;
-		if (((struct _hchk *) parent)->htype == SQL_HANDLE_DBC)
+		if (((TDS_CHK *) parent)->htype == SQL_HANDLE_DBC)
 			odbc_ver = ((TDS_DBC *) parent)->env->attr.odbc_version;
 		else
 			odbc_ver = ((TDS_STMT *) parent)->dbc->env->attr.odbc_version;
-		errs = &((TDS_DESC *) handle)->errs;
 		break;
 	default:
 		return SQL_INVALID_HANDLE;
@@ -579,7 +576,6 @@ SQLError(SQLHENV henv, SQLHDBC hdbc, SQLHSTMT hstmt, SQLCHAR FAR * szSqlState, S
 	 SQLCHAR FAR * szErrorMsg, SQLSMALLINT cbErrorMsgMax, SQLSMALLINT FAR * pcbErrorMsg)
 {
 	SQLRETURN result;
-	struct _sql_errors *errs = NULL;
 	SQLSMALLINT type;
 	SQLHANDLE handle;
 
@@ -587,15 +583,12 @@ SQLError(SQLHENV henv, SQLHDBC hdbc, SQLHSTMT hstmt, SQLCHAR FAR * szSqlState, S
 			henv, hdbc, hstmt, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
 
 	if (hstmt) {
-		errs = &((TDS_STMT *) hstmt)->errs;
 		handle = hstmt;
 		type = SQL_HANDLE_STMT;
 	} else if (hdbc) {
-		errs = &((TDS_DBC *) hdbc)->errs;
 		handle = hdbc;
 		type = SQL_HANDLE_DBC;
 	} else if (henv) {
-		errs = &((TDS_ENV *) henv)->errs;
 		handle = henv;
 		type = SQL_HANDLE_ENV;
 	} else
@@ -605,7 +598,7 @@ SQLError(SQLHENV henv, SQLHDBC hdbc, SQLHSTMT hstmt, SQLCHAR FAR * szSqlState, S
 
 	if (result == SQL_SUCCESS) {
 		/* remove first error */
-		odbc_errs_pop(errs);
+		odbc_errs_pop(&((TDS_CHK *) handle)->errs);
 	}
 
 	return result;
@@ -627,7 +620,7 @@ SQLGetDiagField(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 		SQLSMALLINT cbBuffer, SQLSMALLINT FAR * pcbBuffer)
 {
 	SQLRETURN result = SQL_SUCCESS;
-	struct _sql_errors *errs = NULL;
+	struct _sql_errors *errs;
 	const char *msg;
 
 	SQLINTEGER odbc_ver = SQL_OV_ODBC2;
@@ -635,6 +628,7 @@ SQLGetDiagField(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 	TDS_STMT *stmt = NULL;
 	TDS_DBC *dbc = NULL;
 	TDS_ENV *env = NULL;
+	SQLHANDLE parent;
 	char tmp[16];
 
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetDiagField(%d, %p, %d, %d, %p, %d, %p)\n", 
@@ -643,7 +637,7 @@ SQLGetDiagField(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 	if (cbBuffer < 0)
 		return SQL_ERROR;
 
-	if (!handle  || ((struct _hchk *) handle)->htype != handleType)
+	if (!handle  || ((TDS_CHK *) handle)->htype != handleType)
 		return SQL_INVALID_HANDLE;
 
 	switch (handleType) {
@@ -651,23 +645,32 @@ SQLGetDiagField(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 		stmt = ((TDS_STMT *) handle);
 		dbc = stmt->dbc;
 		env = dbc->env;
-		errs = &stmt->errs;
 		break;
 
 	case SQL_HANDLE_DBC:
 		dbc = ((TDS_DBC *) handle);
 		env = dbc->env;
-		errs = &dbc->errs;
 		break;
 
 	case SQL_HANDLE_ENV:
 		env = ((TDS_ENV *) handle);
-		errs = &env->errs;
+		break;
+
+	case SQL_HANDLE_DESC:
+		parent = ((TDS_DESC *) handle)->parent;
+		if (((TDS_CHK *) parent)->htype == SQL_HANDLE_DBC) {
+			dbc = (TDS_DBC *) parent;
+		} else {
+			stmt = (TDS_STMT *) parent;
+			dbc = stmt->dbc;
+		}
+		env = dbc->env;
 		break;
 
 	default:
 		return SQL_INVALID_HANDLE;
 	}
+	errs = &((TDS_CHK *) handle)->errs;
 	odbc_ver = env->attr.odbc_version;
 
 	/* header (numRecord ignored) */
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 6529b73..0938e37 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.477 2008/03/12 13:54:33 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.478 2008/03/13 13:23:31 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -5602,7 +5602,6 @@ _SQLGetInfo(TDS_DBC * dbc, SQLUSMALLINT fInfoType, SQLPOINTER rgbInfoValue, SQLS
 		SIVAL = SQL_TC_ALL;
 		break;
 	case SQL_TXN_ISOLATION_OPTION:
-		/* TODO check SQLSetConnectAttr support */
 		UIVAL = SQL_TXN_READ_COMMITTED | SQL_TXN_READ_UNCOMMITTED | SQL_TXN_REPEATABLE_READ | SQL_TXN_SERIALIZABLE;
 		break;
 	case SQL_UNION:
diff --git a/src/odbc/odbc_checks.c b/src/odbc/odbc_checks.c
index a55e1a7..713bdcc 100644
--- a/src/odbc/odbc_checks.c
+++ b/src/odbc/odbc_checks.c
@@ -40,7 +40,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_checks.c,v 1.19 2007/05/17 10:33:21 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_checks.c,v 1.20 2008/03/13 13:23:31 freddy77 Exp $");
 
 #if ENABLE_EXTRA_CHECKS
 
@@ -113,7 +113,7 @@ odbc_check_struct_extra(void *p)
 {
 	const int invalid_htype = 0;
 
-	switch (((struct _hchk *) p)->htype) {
+	switch (((TDS_CHK *) p)->htype) {
 	case SQL_HANDLE_ENV:
 		odbc_check_env_extra((TDS_ENV *) p);
 		break;

